import { DocumentedClass, DocumentedClassConstructor, DocumentedClassMethod, DocumentedClassProperty, DocumentedFunction, DocumentedTypes } from '../serializers';
import { FileMetadata } from '../utils';
import { MicroDocgenLink } from '..';
export interface MarkdownGeneratorMarkdownBuild {
    name: string;
    metadata: FileMetadata | null;
    content: string;
}
export interface MarkdownGeneratorMdBuilderOptions {
    linker: (t: string, s: string[]) => string;
    links: MicroDocgenLink;
    includeHeaders: boolean;
}
/**
 * MarkdownGenerator is a class that generates markdown documentation for classes, functions, and types.
 * It transforms the JSON output from the serializer into markdown and applies the necessary formatting or linking.
 */
export declare class MarkdownGenerator {
    options: MarkdownGeneratorMdBuilderOptions;
    linker: typeof this.options.linker;
    constructor(options: MarkdownGeneratorMdBuilderOptions);
    getHeaders(value: DocumentedClass | DocumentedTypes | DocumentedFunction): string;
    getClassHeading(c: DocumentedClass): string;
    getCtor(c: DocumentedClassConstructor): string;
    transformClass(classes: DocumentedClass[]): MarkdownGeneratorMarkdownBuild[];
    transformFunctions(types: DocumentedFunction[]): MarkdownGeneratorMarkdownBuild[];
    transformTypes(types: DocumentedTypes[]): MarkdownGeneratorMarkdownBuild[];
    getTypeMarkdown(t: DocumentedTypes): string;
    getMarkdown(c: DocumentedClass): string;
    getProperties(properties: DocumentedClassProperty[]): string;
    getMethods(methods: DocumentedClassMethod[]): string;
    getFunctions(m: DocumentedFunction): string;
}
