import { FileMetadata } from '../utils';
import { AbstractSerializer } from './AbstractSerializer';
import { DocumentedClassProperty, DocumentedParameter } from './ClassSerializer';
export interface DocumentedTypes {
    name: string;
    description: string | null;
    see: string[];
    private: boolean;
    deprecated: boolean;
    type: string | null;
    properties: DocumentedTypeProperty[];
    parameters: DocumentedParameter[];
    returns: {
        type: string;
        description: string | null;
    } | null;
    metadata: FileMetadata | null;
}
export interface DocumentedTypeProperty extends DocumentedClassProperty {
    value: string | null;
}
export declare class TypesSerializer extends AbstractSerializer {
    serialize(): DocumentedTypes;
}
